/*
 * Copyright (c) 1995, the EUROPAGATE consortium (see below).
 *
 * The EUROPAGATE consortium members are:
 *
 *    University College Dublin
 *    Danmarks Teknologiske Videnscenter
 *    An Chomhairle Leabharlanna
 *    Consejo Superior de Investigaciones Cientificas
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation, in whole or in part, for any purpose, is hereby granted,
 * provided that:
 *
 * 1. This copyright and permission notice appear in all copies of the
 * software and its documentation. Notices of copyright or attribution
 * which appear at the beginning of any file must remain unchanged.
 *
 * 2. The names of EUROPAGATE or the project partners may not be used to
 * endorse or promote products derived from this software without specific
 * prior written permission.
 *
 * 3. Users of this software (implementors and gateway operators) agree to
 * inform the EUROPAGATE consortium of their use of the software. This
 * information will be used to evaluate the EUROPAGATE project and the
 * software, and to plan further developments. The consortium may use
 * the information in later publications.
 * 
 * 4. Users of this software agree to make their best efforts, when
 * documenting their use of the software, to acknowledge the EUROPAGATE
 * consortium, and the role played by the software in their work.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED, OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 * IN NO EVENT SHALL THE EUROPAGATE CONSORTIUM OR ITS MEMBERS BE LIABLE
 * FOR ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF
 * ANY KIND, OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA
 * OR PROFITS, WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND
 * ON ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE
 * USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */
/* Gateway kernel
 * Europagate, 1995
 *
 * $Log: gip.h,v $
 * Revision 1.4  1995/05/22 09:03:38  adam
 * New argument, block, to cs_open.
 *
 * Revision 1.3  1995/05/16  09:39:39  adam
 * LICENSE.
 *
 * Revision 1.2  1995/05/01  16:26:43  adam
 * New function gip_outfileno.
 *
 * Revision 1.1  1995/03/27  08:23:17  adam
 * First version of gip interface (gateway IPc).
 * First version of gw-db: gateway hash db.
 *
 */

typedef struct GIP_info {
    int rfd;
    int wfd;
    char *name;
    int ret;
    int errno;
} *GIP;

GIP gip_initialize (const char *name);
int gip_destroy (GIP gip);
int gip_infileno (GIP gip);
int gip_outfileno (GIP gip);
int gip_errno (GIP gip);
int gip_read (GIP gip, char *buf, size_t count);
int gip_write (GIP gip, const char *buf, size_t count);
int gip_wline (GIP gip, const char *buf);

GIP gipc_initialize (const char *name);
int gipc_destroy (GIP gip);
int gipc_open (GIP gip, const char *server, int sync);
int gipc_close (GIP gip);

GIP gips_initialize (const char *name);
int gips_destroy (GIP gip);
int gips_open (GIP gip, const char *client, int block);
int gips_close (GIP gip);

