#
# $Id: z39util.tcl,v 1.47 1996/09/03 14:06:43 adam Exp $
#
proc saveState {} {
    uplevel #0 {
    set f [open "tcl.state.${sessionId}" w]
    foreach var [info globals] {
        if {$var == "f"} continue
        if {$var == "sessionId"} continue
        if {$var == "errorInfo"} continue
	if {[catch {set names [array names $var]}]} {
            eval "set v \$${var}"
            puts $f "set ${var} \{$v\}"
        } else {
	    foreach n $names {
                eval "set v \$${var}(\$n)"
		puts $f "set ${var}($n) \{$v\}"
	    }
            catch {
                eval "set v \$${var}"
                puts $f "set ${var} \{$v\}"
            }
        }
    }
    close $f
    }
}

proc search-response {zz} {
    global sessionWait

    set status [$zz responseStatus]
    if {[lindex $status 0] == "NSD"} {
        $zz nextResultSetPosition 0
        set code [lindex $status 1]
        set msg [lindex $status 2]
        set addinfo [lindex $status 3]
        displayError "Diagnostic message" \
                "$msg: $addinfo<br>\n(error code $code)"
        set sessionWait -2
    } else {
        set sessionWait 1
    }
}

proc scan-response {zz} {
    global sessionWait

    set status [$zz scanStatus]
    if {$status == 6} {
        displayError "Scan fail" ""
        set sessionWait -2
    } else {
        set sessionWait 1
    }
}

proc ok-response {} {
    global sessionWait
    set sessionWait 1
}

proc fail-response {} {
    global sessionWait
    set sessionWait -1
}

proc display-medium {zset no setNo targetNo} {
    global env
    global sessionId

    set type [$zset type $no]
    if {$type == "SD"} {
        html {<li>}
        set err [lindex [$zset diag $no] 1]
        set add [lindex [$zset diag $no] 2]
        if {$add != {}} {
            set add " :${add}"
        }
        html "${no} Error ${err}${add} <br>\n"
        return
    }
    if {$type != "DB"} {
        return
    }
    html {<li>}
    set rtype [$zset recordType $no]
    switch $rtype {
        SUTRS {
            html { <a href="http:} $env(SCRIPT_NAME) / $sessionId
            html {/showfull.egw/} $setNo + $targetNo + $no + full {">}
            html [join [$zset getSutrs $no]]
            html "</a><br>\n"
            return
        }
    }
    if {![catch {
        set author [$zset getMarc $no field 100 * a]
        set corp [$zset getMarc $no field 110 * a]
        set meet [$zset getMarc $no field 111 * a]
        set title [$zset getMarc $no field 245 * a]
	if {[llength $author] == 0} {
            set cover [$zset getMarc $no field 245 * {[bc]}]
	} else {
            set cover [$zset getMarc $no field 245 * b]
	}
	set location [$zset getMarc $no field 260 * a] 
	set publisher [$zset getMarc $no field 260 * b]
        set year [$zset getMarc $no field 260 * c]
        set score [$zset getMarc $no field 999 * r]
    } dispError ] } {
        html { <a href="http:} $env(SCRIPT_NAME) /
        html $sessionId {/showfull.egw/} $setNo + $targetNo + $no + full {">}
        set p 0
        foreach a $author {
            if {$p} {
                html ", "
            }
            html $a
            set p 1
        }
        foreach a $corp {
            if {$p} {
                html ", "
            }
            html $a
            set p 1
        }
        foreach a $meet {
            if {$p} {
                html ", "
            }
            html $a
            set p 1
        }
        if {$p} {
            html ": "
        }
	set nope 1
        foreach v $title {
            html $v
            set nope 0
        }
        set v [join $cover ""]
        if {[string length $v] > 0} {
            set nope 0
            html $v
        } elseif {$nope} {
            html "No Title"
        }
        html {</a> }
        if {[scan $score %d nscore] == 1} {
            html "; Score " $nscore
        }
    } else {
        html { <a href="http:} $env(SCRIPT_NAME) /
        html $sessionId {/showfull.egw/} $setNo + $targetNo + $no + full {">}
        html {No Title}
        html {</a> }
        html "Error: " $dispError "\n"
    }
    html "<br>\n"
}

proc display-brief {zset no setNo targetNo} {
    global env
    global sessionId

    set type [$zset type $no]
    if {$type == "SD"} {
        html {<li>}
        set err [lindex [$zset diag $no] 1]
        set add [lindex [$zset diag $no] 2]
        if {$add != {}} {
            set add " :${add}"
        }
        html "${no} Error ${err}${add} <br>\n"
        return
    }
    if {$type != "DB"} {
        return
    }
    html {<li>}
    set rtype [$zset recordType $no]
    switch $rtype {
        SUTRS {
            html { <a href="http:} $env(SCRIPT_NAME) / $sessionId
            html {/showfull.egw/} $setNo + $targetNo + $no + full {">}
            html [string range [join [$zset getSutrs $no]] 0 70]
            html "</a><br>\n"
            return
        }
    }
    if {![catch {
        set author [$zset getMarc $no field 100 * a]
        set corp [$zset getMarc $no field 110 * a]
        set meet [$zset getMarc $no field 111 * a]
        set title [$zset getMarc $no field 245 * a]
	if {[llength $author] == 0} {
            set cover [$zset getMarc $no field 245 * {[bc]}]
	} else {
            set cover [$zset getMarc $no field 245 * b]
	}
	set location [$zset getMarc $no field 260 * a] 
	set publisher [$zset getMarc $no field 260 * b]
        set year [$zset getMarc $no field 260 * c]
    } dispError ] } {
        html { <a href="http:} $env(SCRIPT_NAME) /
        html $sessionId {/showfull.egw/} $setNo + $targetNo + $no + full {">}
        set p 0
        foreach a $author {
            if {$p} {
                html ", "
            }
            html $a
            set p 1
        }
        foreach a $corp {
            if {$p} {
                html ", "
            }
            html $a
            set p 1
        }
        foreach a $meet {
            if {$p} {
                html ", "
            }
            html $a
            set p 1
        }
        if {$p} {
            html ": "
        }
        html {<it>}
	set nope 1
        foreach v $title {
            html $v
            set nope 0
        }
        html {</it>}
        if {$nope} {
            set v [join $cover ""]
            if {[string length $v] > 40} {
                set nope 0
                html [string range $v 0 38] "..."
            } elseif {[string length $v] > 0} {
                set nope 0
                html $v
            } else {
                html "No Title"
            }
	}
        html {</a> }
    } else {
        html { <a href="http:} $env(SCRIPT_NAME) /
        html $sessionId {/showfull.egw/} $setNo + $targetNo + $no + full {">}
        html {No Title}
        html {</a> }
        html "Error: " $dispError "\n"
    }
    html "<br>\n"
}

proc display-raw {zset no setNo targetNo} {
    set type [$zset type $no]
    switch $type {
        SD {
            set err [lindex [$zset diag $no] 1]
            set add [lindex [$zset diag $no] 2]
            if {$add != {}} {
                set add " :${add}"
            }
            html "<h3>${no}</h3>\n"
            html "Error ${err}${add} <br>\n"
            return
        }
        DB {
        }
        default {
            return
        }
    }
    set rtype [$zset recordType $no]
    switch $rtype {
        SUTRS {
            html "<xmp>\n" [join [$zset getSutrs $no]] "\n</xmp>\n"
            return
        } 
    }
    if {[catch {set r [$zset getMarc $no line * * *]}]} {
        html "Unknown record type: $rtype <br>\n"
        return
    }
    foreach line $r {
        set tag [lindex $line 0]
        set indicator [lindex $line 1]
        set fields [lindex $line 2]
        set l [string length $indicator]
        html "<tt>$tag "
        if {$l > 0} {
            for {set i 0} {$i < $l} {incr i} {
                if {[string index $indicator $i] == " "} {
                    html "-"
                } else {
                    html [string index $tag $i]
                }
            }
        }
        html "</tt>"
        foreach field $fields {
            set id [lindex $field 0]
            set data [lindex $field 1]
            if {$id != ""} {
                html " <b>\$$id</b> "
            }
            html $data
        }
        html "<br>\n"
    }
}

proc put-marc-contents {cc} {
    set ref ""
    if {[string first :// $cc] > 0} {
        foreach urltype {gopher http ftp mailto} {
            if {[string first ${urltype}:// $cc] == 0} {
                set ref $urltype
                break
            }
        }
    } 
    if {$ref != ""} {
        html {<a href="}
    }
    html $cc
    if {$ref != ""} {
        html {">} $cc {</a>}
    }
}

proc dl-marc-field {zset no tag id la lb sep} {
    set n 0
    set c [$zset getMarc $no field $tag * $id]
    set len [llength $c]
    if {$len == 0} {
        return 0
    }
    if {$len > 1 && "x$lb" != "x"} {
        html "<dt><b>$lb</b>\n<dd>"
    } else {
        html "<dt><b>$la</b>\n<dd>"
    }
    foreach cc $c {
        if {$n > 0} {
            html $sep
        }
        put-marc-contents $cc
        incr n
    }
    return $n
}

proc dd-marc-field {zset no tag id start stop} {
    set n 0
    set c [$zset getMarc $no field $tag * $id]
    set len [llength $c]
    if {$len == 0} {
        return 0
    }
    foreach cc $c {
        html $start
        put-marc-contents $cc
        html $stop
        incr n
    }
    return $n
}

proc dl-marc-field-rec {zset no tag lead start stop startid sep} {
    set n 0
    set lines [$zset getMarc $no line $tag * *]
    foreach line $lines {
        foreach field [lindex $line 2] {
            if {$n == 0} {
                html "<dt><b>$lead</b>"
                html "\n<dd>"
            }
            set id [lindex $field 0]
            if {$id == $startid} {
                if {$n > 0} {
                    html $stop
                }
                html $start
                incr n
                html [lindex $field 1]
            } else {
                html $sep
                html [lindex $field 1]
            }
        }
    }
    if {$n > 0} {
        html $stop
    }
}

proc display-full-marc {zset no setNo targetNo} {
    global env
    global hist
    global sessionId

    html "<dl>\n"
    set n [dl-marc-field $zset $no 700 a "Author" "Authors" "<br>\n"]
    if {$n == 0} {
        set n [dl-marc-field $zset $no 100 a "Author" "Authors" "<br>\n"]
    }
    set n [dl-marc-field $zset $no 710 a "Corporate Name" {} ", "]
    if {$n == 0} {
        set n [dl-marc-field $zset $no 110 a "Corporate Name" {} ", "]
    }
    set n [dl-marc-field $zset $no 711 a "Meeting Name" {} ", "]
    if {$n > 0} {
	dd-marc-field $zset $no 711 {[bndc]} " " ""
    } else {
        set n [dl-marc-field $zset $no 111 a "Meeting Name" {} ", "]
	if {$n > 0} {
	    dd-marc-field $zset $no 111 {[bndc]} " " " "
	}
    } 
    set n [dl-marc-field $zset $no 245 {a} "Title" {} " "]
    if {$n > 0} {
        dd-marc-field $zset $no 245 b "<em>" "</em>"
        dd-marc-field $zset $no 245 c " " ""
    } else {
        dl-marc-field $zset $no 245 {[ab]} "Title" {} " "
    }
    dl-marc-field $zset $no 520 a "Abstract" {} ", "
    dl-marc-field $zset $no 072 * "Subject code" "Subject codes" ", "
    dl-marc-field $zset $no 650 * "Subject" {} ", "
    dl-marc-field $zset $no 260 * "Publisher" {} " "
    dl-marc-field $zset $no 300 * "Physical Description" {} " "

    dl-marc-field-rec $zset $no 500 "Notes" "" "<br>\n" "a" ", "

    dl-marc-field-rec $zset $no 510 "References" "" "<br>\n" "a" ", "

    dl-marc-field-rec $zset $no 511 "Participant note" "" "<br>\n" "a" ", "

    dl-marc-field $zset $no 513 a "Report type" {} ", "
    dl-marc-field $zset $no 513 b "Period covered" {} ", "
    dl-marc-field-rec $zset $no 515 "Numbering notes" "" "<br>\n" "a" ", "
    dl-marc-field-rec $zset $no 516 "Data notes" "" "<br>\n" "a" ", "
    dl-marc-field-rec $zset $no 518 "Date/time notes" "" "<br>\n" "a" ", "

    dl-marc-field $zset $no 350 a "Price" {} ", "
    dl-marc-field $zset $no 362 a "Dates of publication" {} ", "
    dl-marc-field $zset $no 850 a "Holdings" {} ", "

    dl-marc-field-rec $zset $no 270 "Contact name" "" "<br>\n" p ", "
    if {0} {
        set n [dl-marc-field $zset $no 270 p "Contact name" {} ", "]
        if {$n > 0} {
            html "\n<dl>\n"
            
            if {0} {
                dl-marc-field $zset $no 270 a "Street" {} ", "
                dl-marc-field $zset $no 270 b "City" {} ", "
                dl-marc-field $zset $no 270 c "State" {} ", "
                dl-marc-field $zset $no 270 e "Zip code" {} ", "
                dl-marc-field $zset $no 270 d "Country" {} ", "
                dl-marc-field $zset $no 270 m "Network address" {} ", "
                dl-marc-field $zset $no 301 a "Service hours" {} ", "
                dl-marc-field $zset $no 270 k "Phone" {} ", "
                dl-marc-field $zset $no 270 l "Fax" {} ", "
            } else {
                dl-marc-field $zset $no 270 {[abcedmakl]} "Address" {} "<br>\n"
            }
            
            html "\n</dl>\n"
        }
    }
    dl-marc-field $zset $no 010 a "LC control number" {} ", "
    dl-marc-field $zset $no 010 b "NUCMC control number" {} ", "
    dl-marc-field $zset $no 020 a "ISBN" {} ", "
    dl-marc-field $zset $no 022 a "ISSN" {} ", "
    set url [$zset getMarc $no field 856 * u]
    set sp [$zset getMarc $no field 856 * 3]
    if {"x$url" != "x"} {
        html "<dt><b>URL</b>\n"
        if {"x$sp" == "x"} {
            set sp $url
        }
        html {<dd><a href="} [join $url] {">} [join $sp] "</a>\n"
    }
    dl-marc-field $zset $no 037 {[abc]} "Acquisition" {} "<br>\n"
    dl-marc-field $zset $no 037 {[f6]} "Form of issue" {} "<br>\n"
    dl-marc-field $zset $no 537 * "Source of data" {} "<br>\n"
    dl-marc-field $zset $no 538 * "System details" {} "<br>\n"
    dl-marc-field $zset $no 787 {[rstw6]} "Related information" {} "<br>\n"
    dl-marc-field $zset $no 999 r "Score" {} ", "
    dl-marc-field $zset $no 001 * "Local control number" {} ", "
    html "</dl>\n"
}

proc display-full {zset no setNo targetNo} {
    set type [$zset type $no]
    switch $type {
        SD {
            set err [lindex [$zset diag $no] 1]
            set add [lindex [$zset diag $no] 2]
            if {$add != {}} {
                set add " :${add}"
            }
            html "Error ${err}${add} <br>\n"
            return
        }
        DB {
        }
        default {
            return
        }
    }
    set rtype [$zset recordType $no]
    switch $rtype {
        SUTRS {
            html "<pre>" [join [$zset getSutrs $no]] "</pre><br>\n"
            return
        }
    }
    if {[catch {set r [$zset getMarc $no line * * *]}]} {
        html "Unknown record type: $rtype <br>\n"
        return
    }
    display-full-marc $zset $no $setNo $targetNo
}


proc display-rec {from to dfunc setNo targetNo} {
    while {$from <= $to} { 
        eval "$dfunc z39${targetNo}.${setNo} $from $setNo $targetNo"
        incr from
    }
}

proc build-scan {t i} {
    global targets

    set term [egw_form entry$i]
    if {$term != ""} {
        set field [join [egw_form menu$i]]
        set attr {Title}
        foreach x [lindex $targets($t) 2] {
            if {[lindex $x 0] == $field} {
                set attr [lindex $x 1]
            }
        }
        return [list $term $attr]
    }
    return ""
}

proc build-query {t ilines} {
    global targets

    set op {}
    set q {}
    for {set i 1} {$i <= $ilines} {incr i} {
        set term [join [egw_form entry$i]]
        if {[string length $term] == 0} continue
        set field [join [egw_form menu$i]]
        catch {unset attr}
        foreach x [lindex $targets($t) 2] {
            if {![string compare [lindex $x 0] $field]} {
                set attr [lindex $x 1]
            }
        }
        if {![info exists attr]} {
            egw_log debug "attr failed for $t"
            set attr [lindex [lindex [lindex $targets($t) 2] 0] 1]
        }
        egw_log debug "op=${op}"
        switch $op {
            And
            { set q "@and $q ${attr} \"${term}\""; egw_log debug AND }
            Or
            { set q "@or $q ${attr} \"${term}\""; egw_log debug OR }
            {}
            { set q "${attr} \"${term}\""; egw_log debug NOPE }
            default
           { set q "@not $q ${attr} \"${term}\""; egw_log debug ANDNOT }
        }
        set op [egw_form logic$i]
    }
    return $q
}

proc z39scan {setNo scanNo tno scanLines scanPos cache} {
    global hist
    global sessionWait
    global targets

    set zz z39$tno
    set host $hist($setNo,$tno,host)
    set idAuth $hist($setNo,$tno,idAuthentication)
    set database $hist($setNo,$tno,database)
    set scanAttr $hist($setNo,scanAttr)
    set scanTerm $hist($setNo,$scanNo,scanTerm)

    mkAssoc $zz $host
    if {[catch [list set oldHost [$zz connect]]]} {
        set oldHost ""
    }
    set zs $zz.s$scanNo.$setNo
    $zz callback ok-response
    $zz failback fail-response
    set thisHost [splitHostSpec $host]
    if {[string compare $oldHost $thisHost]} {
        catch [list $zz disconnect]

        set sessionWait 0
        if {[catch [list $zz connect $thisHost]]} {
            displayError "Cannot connect to target" $thisHost
            return 0
        } elseif {$sessionWait == 0} {
            if {[catch {egw_wait sessionWait 300}]} {
		$zz disconnect
                displayError "Cannot connect to target" $thisHost
                return 0
            }
            if {$sessionWait != 1} {
                displayError "Cannot connect to target" $thisHost
                return 0
            }
        }
        $zz idAuthentication $idAuth
        set sessionWait 0
        if {[catch {$zz init}]} {
            displayError "Cannot initialize target" $thisHost
	    $zz disconnect
            return 0
        }
        if {[catch {egw_wait sessionWait 60}]} {
            displayError "Cannot initialize target" $thisHost
	    $zz disconnect
            return 0
        }
        if {$sessionWait != "1"} {
            displayError "Cannot initialize target" $thisHost
	    $zz disconnect
            return 0
        }
        if {![$zz initResult]} {
            set u [$zz userInformationField]
            $zz disconnect
            displayError "Cannot initialize target $thisHost" $u
            return 0
        }
    } else {
        if {$cache && ![catch [list $zs numberOfTermsRequested 5]]} {
            return 1
        }
    }
    eval $zz databaseNames $database

    ir-scan $zs $zz

    $zs numberOfTermsRequested $scanLines
    $zs preferredPositionInResponse $scanPos

    $zz callback [list scan-response $zs]

    egw_log debug "scan: ${scanAttr} ${scanTerm}"
    set sessionWait 0
    $zs scan "${scanAttr} ${scanTerm}"

    if {[catch {egw_wait sessionWait 60}]} {
        egw_log debug "timeout/cancel in scan"
        displayError "Timeout in scan" {}
        html "</body></html>\n"
        $zz disconnect
        return 0
    }
    if {$sessionWait == -1} {
        displayError "Scan fail" "Connection closed"
        html "</body></html>\n"
        $zz disconnect
    }
    if {$sessionWait != 1} {
	return 0
    }
    return 1
}

proc display-scan {setNo scanNo tno} {
    global hist
    global targets
    global env
    global sessionId
    global scriptQuery

    set zz z39$tno
    set zs $zz.s$scanNo.$setNo
    set m [$zs numberOfEntriesReturned]
        
    if {$m > 0} {
        set t [lindex [$zs scanLine 0] 1]
        if {$tno > 0} {
            set hist($setNo,$tno,[expr $scanNo - 1],scanTerm) $t
        } else {
            set hist($setNo,[expr $scanNo - 1],scanTerm) $t
        }
        set t [lindex [$zs scanLine [expr $m - 1]] 1]
        if {$tno > 0} {
            set hist($setNo,$tno,[expr $scanNo + 1],scanTerm) $t
        } else {
            set hist($setNo,[expr $scanNo + 1],scanTerm) $t
        }
    }
    html {<table width=500 border=0><tr>}
    html {<td align=left><b>Scan term</b>}
    html {<td align=right><b>Hits</b>}
    html {<tr>} \n

    for {set i 0} {$i < $m} {incr i} {
        html {<td align=left>}
        if {0} {
            regsub -all {\ } [lindex [$zs scanLine $i] 1] + tterm
            html {<a href="http:} $env(SCRIPT_NAME)
            html / $sessionId / $scriptQuery {;/} $setNo + $hist($setNo,host) +
            html $hist($setNo,scan) +  $tterm {">}
        } else {
            regsub -all {\ } [lindex [$zs scanLine $i] 1] + tterm
            html {<a href="http:} $env(SCRIPT_NAME)
            html / $sessionId {/search.egw/} $setNo + $tno +
            html hyper + $tterm {">}
        }
        html [lindex [$zs scanLine $i] 1]
        html {</a>} 
        html {<td align=right>}
        html [lindex [$zs scanLine $i] 2]
        html {<tr>} \n
    }
    html {</table} \n
}

proc z39search {setNo piggy tno elements} {
    global hist
    global sessionWait
    global targets

    set zz z39$tno
    set host $hist($setNo,$tno,host)
    set idAuth $hist($setNo,$tno,idAuthentication)
    set database $hist($setNo,$tno,database)
    set query $hist($setNo,$tno,query)
    catch {set docId $hist($setNo,$tno,queryId)}

    mkAssoc $zz $host
    if {[catch [list set oldHost [$zz connect]]]} {
        set oldHost ""
    }
    $zz callback ok-response
    $zz failback fail-response
    set thisHost [splitHostSpec $host]
    if {[string compare $oldHost $thisHost]} {
        catch [list $zz disconnect]

        set sessionWait 0
        if {[catch [list $zz connect $thisHost]]} {
            displayError "Cannot connect to target" $thisHost
            return 0
        } elseif {$sessionWait == 0} {
            if {[catch {egw_wait sessionWait 300}]} {
		$zz disconnect
                displayError "Cannot connect to target" $thisHost
                return 0
            }
            if {$sessionWait != 1} {
                displayError "Cannot connect to target" $thisHost
                return 0
            }
        }
        $zz idAuthentication $idAuth
        set sessionWait 0
        if {[catch {$zz init}]} {
            displayError "Cannot initialize target" $thisHost
	    $zz disconnect
            return 0
        }
        if {$sessionWait == 0 && [catch {egw_wait sessionWait 60}]} {
            displayError "Cannot initialize target" $thisHost
	    $zz disconnect
            return 0
        }
        if {$sessionWait != "1"} {
            displayError "Cannot initialize target" $thisHost
	    $zz disconnect
            return 0
        }
        if {![$zz initResult]} {
            set u [$zz userInformationField]
            $zz disconnect
            displayError "Cannot initialize target $thisHost" $u
            return 0
        }
    } elseif {![catch  [list $zz.$setNo smallSetUpperBound 0]]} {
        if {[info exists hist($setNo,$tno,hits)]} {
            return 1
        }
    }
    
    ir-set $zz.$setNo $zz
    $zz.$setNo preferredRecordSyntax [lindex $targets($host) 1]
    egw_log debug "set syntax to [lindex $targets($host) 1]"
    if {![lindex $targets($host) 5]} {
        set elements {}
    }
    $zz.$setNo smallSetElementSetNames $elements
    $zz.$setNo mediumSetElementSetNames $elements
    $zz.$setNo recordElements $elements

    egw_log debug "database=$database"
    eval $zz.$setNo databaseNames $database

    $zz callback [list search-response $zz.$setNo]
    if {$piggy} {
        $zz.$setNo largeSetLowerBound 999999
        $zz.$setNo smallSetUpperBound 0
        $zz.$setNo mediumSetPresentNumber $hist($setNo,maxPresent)
    } else {
        $zz.$setNo largeSetLowerBound 2
        $zz.$setNo smallSetUpperBound 0
        $zz.$setNo mediumSetPresentNumber 0
    }
    set sessionWait 0
    egw_log debug "search: $query"

    if {[info exists docId]} {
        $zz.$setNo search $query $docId
    } else {
        $zz.$setNo search $query
    }

    if {!$sessionWait && [catch {egw_wait sessionWait 60}]} {
        egw_log debug "timeout/cancel in search"
        displayError "Timeout in search" {}
        html "</body></html>\n"
        $zz disconnect
        return 0
    }
        
    if {$sessionWait == -1} {
        displayError "Search fail" "Connection closed"
        html "</body></html>\n"
        $zz disconnect
    }
    if {$sessionWait != 1} {
	return 0
    }
    set hist($setNo,$tno,hits) [$zz.$setNo resultCount]
    return 1
}

proc init-m-response {i} {
    global zstatus
    global zleft

    egw_log debug "init-m-response"

    incr zleft -1
    if {![z39$i initResult]} {
        set zstatus($i) -1
        z39$i disconnect
        return
    }
    set zstatus($i) 1
}

proc connect-m-response {i} {
    global zstatus
    global zleft

    egw_log debug "connect-m-response"
    z39$i callback [list init-m-response $i]
    if {[catch {z39$i init}]} {
        set zstatus($i) -1
        incr zleft -1
    }
}

proc fail-m-response {i} {
    global zstatus
    global zleft
    
    egw_log debug "fail-m-response"
    set zstatus($i) -1
    incr zleft -1
}

proc search-m-response {setNo i start number} {
    global zleft
    global zstatus
    global hist

    egw_log debug "search-m-response"
    set status [z39$i.$setNo responseStatus]
    egw_log debug "search-m-response1"
    if {[lindex $status 0] == "OK"} {
        set nor 0
    } elseif {[lindex $status 0] == "DBOSD"} {
        set nor [z39$i.$setNo numberOfRecordsReturned]
    } else {
        egw_log debug "search-m-response2"
        incr zleft -1
        set zstatus($i) 2
        return
    }
    set hist($setNo,$i,hits) [z39$i.$setNo resultCount]
    egw_log debug "search-m-response3"
    set hist($setNo,$i,offset) [expr $start + $nor -1]
    if {[expr $nor + $start] > [z39$i.$setNo resultCount]} {
        egw_log debug "search-m-response4"
        incr zleft -1
        set zstatus($i) 2
        return
    }
    egw_log debug "search-m-response5"
    if {$nor >= $number} {
        egw_log debug "search-m-response6 nor=$nor number=$number"
        incr zleft -1
        set zstatus($i) 2
        return
    }
    egw_log debug "search-m-response7"
    set start [expr $start + $nor]
    set number [expr $number - $nor]
    if {[expr $start + $number - 1] > [z39$i.$setNo resultCount]} {
        set number [expr [z39$i.$setNo resultCount] - $start + 1]
    }
    z39$i callback [list search-m-response $setNo $i $start $number]
    egw_log debug "mpresent start=$number number=$number"
    z39$i.$setNo present $start $number
}

proc z39msearch {setNo elements start number cache} {
    global zleft
    global zstatus
    global hist
    global targets
    global debug

    set not $hist($setNo,0,host)

    egw_log debug "z39msearch start=$start number=$number elements=$elements"
    for {set i 1} {$i <= $not} {incr i} {
        set host $hist($setNo,$i,host)
        mkAssoc z39$i $host
        set oldHost [z39$i connect]
        set thisHost [splitHostSpec $host]
        if {[string compare $oldHost $thisHost]} {
            catch {z39$i disconnect}
        }
        z39$i callback [list connect-m-response $i]
        z39$i failback [list fail-m-response $i]
    }
    set zleft 0
    for {set i 1} {$i <= $not} {incr i} {
        set oldHost [z39$i connect]
        set host $hist($setNo,$i,host)
        set thisHost [splitHostSpec $host]
        if {![string compare $oldHost $thisHost]} {
            continue
        }
        egw_log debug "old=$oldHost this=$thisHost"
        z39$i idAuthentication $hist($setNo,$i,idAuthentication)
        html "Connecting to target " $thisHost " <br>\n"
        set zstatus($i) -1
        if {![catch {z39$i connect $thisHost}]} {
            incr zleft
        } 
    }
    while {$zleft > 0} {
        egw_log debug "Waiting for init response"
        if {[catch {egw_wait zleft 20} reason]} {
            if {![string compare $reason cancel]} {
                for {set i 1} {$i <= $not} {incr i} {
                    set zstatus($i) -1
                    catch {z39$i disconnect}
                }
                return
            } else {
                for {set i 1} {$i <= $not} {incr i} {
                    if {$zstatus($i) == -1} {
                        catch {z39$i disconnect}
                    }
                }
            }
            break
        }
    }
    set zleft 0
    for {set i 1} {$i <= $not} {incr i} {
        set host $hist($setNo,$i,host)
        if {$debug} {
            html "host " [splitHostSpec $host] ": "
        }
        egw_log debug "i=$i zstatus=$zstatus($i)"
        if {$zstatus($i) < 1} {
            if {$debug} {
                html "fail<br>\n"
            }
            continue
        }
        if {[catch [list z39$i.$setNo preferredRecordSyntax]]} {
            if {$debug} {
                html "ok<br>\n"
            }

            ir-set z39$i.$setNo z39$i
            z39$i.$setNo preferredRecordSyntax [lindex $targets($host) 1]
            egw_log debug "set syntax to [lindex $targets($host) 1]"
            set hist($setNo,$i,offset) 0
            eval z39$i.$setNo databaseNames $hist($setNo,$i,database)

            if {![lindex $targets($hist($setNo,$i,host)) 5]} {
                set thisElements {}
            } else {
                set thisElements $elements
            }
            z39$i.$setNo smallSetElementSetNames $thisElements
            z39$i.$setNo mediumSetElementSetNames $thisElements
            z39$i.$setNo elementSetNames $thisElements
            z39$i.$setNo recordElements $thisElements

            z39$i callback [list search-m-response $setNo $i $start $number]

            if {$start == 1} {
                z39$i.$setNo largeSetLowerBound 999999
                z39$i.$setNo smallSetUpperBound 0
                z39$i.$setNo mediumSetPresentNumber $number
            } else {
                z39$i.$setNo largeSetLowerBound 2
                z39$i.$setNo smallSetUpperBound 0
                z39$i.$setNo mediumSetPresentNumber 0
            }
            set zstatus($i) 1
            incr zleft
            egw_log debug "msearch host=" $hist($setNo,$i,host)
            egw_log debug "setNo=$setNo query=" $hist($setNo,$i,query) "="
            if {[catch {z39$i.$setNo search $hist($setNo,$i,query)}]} {
                set zstatus($i) -1
                incr zleft -1
            }
        } elseif {[z39$i.$setNo resultCount] >= $start} {
            if {[expr $start + $number - 1] > [z39$i.$setNo resultCount]} {
                set tnumber [expr [z39$i.$setNo resultCount] - $start + 1]
            } else {
                set tnumber $number
            }
            if {![lindex $targets($hist($setNo,$i,host)) 5]} {
                set thisElements {}
            } else {
                set thisElements $elements
            }
            z39$i.$setNo smallSetElementSetNames $thisElements
            z39$i.$setNo mediumSetElementSetNames $thisElements
            z39$i.$setNo elementSetNames $thisElements
            z39$i.$setNo recordElements $thisElements

            for {set n 0} {$n < $tnumber} {incr n} {
                if {[z39$i.$setNo recordType [expr $start + $n]] == ""} {
                    if {$n > 0} {
                        egw_log debug "failed on $n"
                    }
                    if {$debug} {
                        html "no record at #" [expr $start + $n]
                        html " el=-" $thisElements "-"
                    }
                    break
                }
            }
            if {$n == $tnumber} {
                if {$debug} {
                    html "cached<br>\n"
                }
                continue
            }
            
            html "present<br>\n"
            z39$i callback [list search-m-response $setNo $i $start $tnumber]
            incr zleft
            egw_log debug "mpresent start=$start number=$tnumber"
            z39$i.$setNo present $start $tnumber
        } else {
            if {$debug} {
                html "ok<br>\n"
            }
        }
    }


    while {$zleft > 0} {
        egw_log debug "Waiting for search/present response"
        if {[catch {egw_wait zleft 60} reason]} {
            if {![string compare $reason cancel]} {
                for {set i 1} {$i <= $not} {incr i} {
                    catch {z39$i disconnect}
                    set zstatus($i) -1
                }
                return
            } else {
                for {set i 1} {$i <= $not} {incr i} {
                    if {$zstatus($i) != 2} {
                        catch {z39$i disconnect}
                    }
                }
            }
            break
        }
    }
    for {set i 1} {$i <= $not} {incr i} {
        if {$zstatus($i) != 2} continue
        set status [z39$i.$setNo responseStatus]
        if {0 && [lindex $status 0] != "NSD"} {
            set hist($setNo,$i,offset) [z39$i.$setNo numberOfRecordsReturned]
        }
    }
}

proc z39present {setNo tno setOffset setMax dfunc elements} {
    global hist
    global sessionWait
    global targets

    set zz z39$tno
    set host $hist($setNo,$tno,host)

    if {![lindex $targets($host) 5]} {
        set elements {}
    }

    $zz.$setNo elementSetNames $elements
    $zz.$setNo recordElements $elements
    set toGet [expr 1 + $setMax - $setOffset]

    $zz callback [list search-response $zz.$setNo]

    while {$setMax > 0 && $toGet > 0} {
        for {set got 0} {$got < $toGet} {incr got} {
            if {[$zz.$setNo recordType [expr $setOffset + $got]] == ""} {
                break
            }
        }
        if {$got < $toGet} {
            set sessionWait 0
            $zz.$setNo present $setOffset $toGet
            if {[catch {egw_wait sessionWait 300}]} {
                egw_log debug "timeout/cancel in present"
		$zz disconnect
                break
	    }
            if {$sessionWait == "0"} {
                $zz disconnect
            }
            if {$sessionWait != "1"} {
                break
            }
            set got [$zz.$setNo numberOfRecordsReturned]
            if {$got <= 0} {
                break
            }
        }
        display-rec $setOffset [expr $got + $setOffset - 1] $dfunc $setNo $tno
        set setOffset [expr $got + $setOffset]
        set toGet [expr 1 + $setMax - $setOffset]
        egw_flush
    }
}

proc buttons-result-set-s {setNo targetNo setMax startPos after} {
    global sessionId
    global useIcons
    global env
    global hist

    set zz z39$targetNo
    html "<p>\n"
    button-main
    if {$setMax > 0 && $setMax < [$zz.$setNo resultCount]} {
        if {!$useIcons} {
            html "\n | "
        }
        html {<a href="http:} $env(SCRIPT_NAME)
        html / $sessionId {/search.egw/} $setNo + $targetNo + 
        html [expr $setMax + 1] + [expr $setMax + $hist($setNo,maxPresent)]
        if {$useIcons} {
            html {"><img src="/egwgif/button-next-records.gif" }
            html {alt="Next Records" border=0></a>}
        } else {
            html {">Next Records</a>}
        }
    }
    if {$setMax > 0 && $startPos != "" && $startPos != "1"} {
        if {!$useIcons} {
            html "\n | "
        }
        html {<a href="http:} $env(SCRIPT_NAME)
        html / $sessionId {/search.egw/} $setNo + $targetNo
        html + [expr $startPos - $hist($setNo,maxPresent)]
        html + [expr $startPos - 1]
        if {$useIcons} {
            html {"><img src="/egwgif/button-previous-records.gif" }
	    html {alt="Previous Records" border=0></a>}
        } else {
            html {">Previous Records</a>} 
        }
    }
    if {$targetNo > 0} {
        button-result-set $setNo $targetNo
    }
    button-new-query $setNo
    button-new-target
    button-view-history

    html "<p>\n"
}

proc score-sort {l r} {
    return [expr [lindex $r 0] - [lindex $l 0]]
}

proc display-result-set-m-score {setNo} {
    global hist
    global useIcons
    global zstatus
    global targets

    set not $hist($setNo,0,host)
    for {set i 1} {$i <= $not} {incr i} {
        if {$zstatus($i) != 2} continue
        set status [z39$i.$setNo responseStatus]
        if {[lindex $status 0] != "DBOSD"} continue        
        set nor $hist($setNo,$i,offset)
        for {set j 1} {$j <= $nor} {incr j} {
            if {![string compare [z39$i.$setNo recordType $j] USmarc]} {
                set score [z39$i.$setNo getMarc $j field 999 * r]
                if {[scan $score %d score] != 1} {
                    set score 10
                }
            } else {
                set score 10
            }
            if {$score > 0} {
                lappend scoreArray [list $score $i $j]
            }
        }
    }
    if {![info exists scoreArray]} {
        html "<br><h3>Search produced no result</h3><br>\n"
    } else {
        html "<ul>\n"
        set scoreSorted [lsort -command score-sort $scoreArray]
        foreach r $scoreSorted {
            set i [lindex $r 1]
            set j [lindex $r 2]
            display-$hist($setNo,format) z39$i.$setNo $j $setNo $i
        }
        html "<br></ul>\n"
    }
    for {set i 1} {$i <= $not} {incr i} {
        if {$zstatus($i) != 2} continue
        set status [z39$i.$setNo responseStatus]
        if {[lindex $status 0] == "NSD"} {
            z39$i.$setNo nextResultSetPosition 0
            set code [lindex $status 1]
            set msg [lindex $status 2]
            set addinfo [lindex $status 3]
            html {<dt>} [lindex $targets($hist($setNo,$i,host)) 0] 
            html "<dd>Error: $msg: $addinfo (code $code)<br>\n"
        }
    }
    html "\n<br>"
}

proc display-result-set-m-server {setNo} {
    global hist
    global useIcons
    global zstatus
    global targets
    global env
    global sessionId

    set not $hist($setNo,0,host)
    html "<dl>\n"
    for {set i 1} {$i <= $not} {incr i} {
        if {$zstatus($i) != 2} continue
        set status [z39$i.$setNo responseStatus]
        if {[lindex $status 0] == "NSD"} {
            html "<dt><h3>" [lindex $targets($hist($setNo,$i,host)) 0] ": "
            z39$i.$setNo nextResultSetPosition 0
            set code [lindex $status 1]
            set msg [lindex $status 2]
            set addinfo [lindex $status 3]
            html "Error</h3>\n<dd>NSD$code: $msg: $addinfo"
        } else {
            html {<dt><a href="http:} $env(SCRIPT_NAME)
            html / $sessionId {/search.egw/} $setNo + $i + 1
            html + $hist($setNo,maxPresent) {">}
            html "<h3>" [lindex $targets($hist($setNo,$i,host)) 0] "</a>: "
            set r [z39$i.$setNo resultCount]
            html "$r hits</h3>\n<dd>\n"
            
            if {$hist($setNo,$i,offset) > $hist($setNo,maxPresent)} {
                set nor $hist($setNo,maxPresent)
            } else {
                set nor $hist($setNo,$i,offset)
            }
            display-rec 1 $nor display-$hist($setNo,format) $setNo $i
        }
        html "\n"
    }
    html "</dl>\n"
}

proc display-result-set-m {setNo} {
    global hist
    global useIcons
    global zstatus
    global targets

    egw_log debug "sort=$hist($setNo,sort)"
    switch $hist($setNo,sort) {
        score {
            display-result-set-m-score $setNo
        }
        default {
            display-result-set-m-server $setNo
        }
    }
}

proc display-result-set-s {setNo targetNo startPos endPos} {
    global hist
    global useIcons

    set zz z39$targetNo
    set host $hist($setNo,$targetNo,host)
    set idAuth $hist($setNo,$targetNo,idAuthentication)
    set database $hist($setNo,$targetNo,database)
    set query $hist($setNo,$targetNo,query)

    set useIcons 1

    if {$startPos == ""} {
        if {[z39search $setNo 1 $targetNo B] != "1"} {
            return
        }
        set r [$zz.$setNo resultCount]

        set setMax [$zz.$setNo resultCount]
        if {$setMax > $hist($setNo,maxPresent)} {
            set setMax $hist($setNo,maxPresent)
        }
        buttons-result-set-s $setNo $targetNo $setMax $startPos 0

        set setOffset [$zz.$setNo numberOfRecordsReturned]
        if {$setMax > 0} {
            html {<h3> Records 1-} $setMax " out of $r</h3>\n"
        } else {
            html "<h3> No hits</h3>\n"
        }
        egw_flush
        html "<ul>\n"
        display-rec 1 $setMax display-brief $setNo $targetNo
        incr setOffset

    } else {
        if {[z39search $setNo 0 $targetNo B] != "1"} {
            return 
        }
        set r [$zz.$setNo resultCount]
        set setOffset $startPos
        set setMax [$zz.$setNo resultCount]
        if {$setMax > $endPos} {
            set setMax $endPos
        }
        buttons-result-set-s $setNo $targetNo $setMax $startPos 0
        if {$setMax > 0} {
            html {<h3> Records } $startPos {-} $setMax " out of $r</h3>\n"
        } else {
            html "<h3> No hits</h3>\n"
        }
        egw_flush
        html "<ul>\n"
    }
    if {$setMax > 0} {
        z39present $setNo $targetNo $setOffset $setMax display-brief B
    }
    html "</ul>\n"
    set useIcons 0
    buttons-result-set-s $setNo $targetNo $setMax $startPos 1
}

proc z39history {} {
    global nextSetNo
    global hist
    global env
    global sessionId
    global targets
    global html3
    global scriptQuery

    if {![info exists nextSetNo]} {
        return
    }
    html "<h2>History</h2><br>\n"
    if {$html3} {
        html {<table width=500 border=1><tr>}
        html {<td align=center><b>Target</b>}
        html {<td align=center><b>Database</b>}
        html {<td align=center><b>Hits</b>}
        html {<td align=center><b>Query</b>}
        html {<tr>} "\n"
    } else {
        html {<dl>} "\n"
    }
    for {set setNo 1} {$setNo < $nextSetNo} {incr setNo} {
        if {[info exists hist($setNo,scan)]} {
            if {$hist($setNo,scan) > 0} continue
        }
        if {[info exists hist($setNo,1,host)]} {
            set start 1
            set end $hist($setNo,0,host)
        } else {
            set start 0
            set end 0
        }
        for {set i $start} {$i <= $end} {incr i} {
            if {$html3} {
                html {<td align=left>}
            } else {
                html {<dt> }
            }
            set host $hist($setNo,$i,host)
            html [lindex $targets($host) 0]
            if {$html3} {
                html {<td align=left>} [join $hist($setNo,$i,database)]
            } else {
                if {[llength [lindex $targets($host) 1]] > 1} {
                    html ": "
                    foreach b $hist($setNo,$i,database) {
                        html " $b"
                    }
                }
                html {. }
            }
            if {$html3} {
                html {<td align=right>}
            }
            if {[info exists hist($setNo,$i,hits)]} {
                html { <a href="http:} $env(SCRIPT_NAME)
                html / $sessionId {/search.egw/} $setNo + $i + 1
                html + $hist($setNo,maxPresent)
                html {">} $hist($setNo,$i,hits) {</a>}
            } else {
                if {$html3} {
                    html {Failed}
                } else {
                    html {Search failed.}
                }
            }
            if {$html3} {
                html {<td align=left>}
            } else {
                html "<dd>\n"
            }
            html { <a href="http:} $env(SCRIPT_NAME)
            html / $sessionId / $scriptQuery {;/} $setNo + $host
            if {$html3} {
                html {">}
            } else {
                html {">Query</a>: }
            }
            set op {}
            for {set j 1} {$j <= 10} {incr j} {
                if {![info exists hist($setNo,form,entry$j)]} {
                    break
                }
                if {[string length $hist($setNo,form,entry$j)] > 0} {
                    html " <b>" [join $op " "] "</b> "
                set pre [join $hist($setNo,form,menu$j)]
                    if {[string length $pre] > 0} {
                        html $pre "="
                    }
                    html $hist($setNo,form,entry$j)
                    set op $hist($setNo,form,logic$j)
                }
            }
            if {$html3} {
                html {</a><tr>} "\n"
            }
        }
    }
    if {$html3} {
        html {</table><p>}
    } else {
        html {</dl>}
    }
    html "\n"
}

proc displayError {msga msgb} {
    html "<p><center>\n"
    html {<img src="/egwgif/noway.gif" alt="Error">}
    html "<h2>" $msga "</h2>\n"
    if {[string length $msgb] > 0} {
        html "<h3>" $msgb "</h3>\n"
    }
    html "</center><p>\n"
}

proc button-main {} {
    global useIcons
    html {<a href="http://europagate.dtv.dk/">}
    if {$useIcons} {
        html {<img src="/egwgif/button-egw.gif" alt="Europagate" border=0></a>}
    } else {
        html {Europagate</a>}
    }
}

proc button-feedback {} {
    global useIcons

    html {<a href="http://europagate.dtv.dk/wwwquest.html">}
    if {$useIcons} {
        html {<img src="/egwgif/button-user-feedback.gif" alt="User Feedback"
        border=0></a>}
    } else {
        html "\n | "
        html {User Feedback</a>}
    }    
}

proc button-define-target {} {
    global useIcons
    global env
    global sessionId

    if {!$useIcons} {
        html "\n | "
    }
    html {<a href="http:} $env(SCRIPT_NAME)
    html / $sessionId {/tform.egw}
    if {$useIcons} {
        html {"><img src="/egwgif/button-define-target.gif" }
	html {alt="Define Target" border=0></a>}
    } else {
        html {">Define Target</a>}
    }
}

proc button-new-target {} {
    global useIcons
    global env
    global sessionId
    global scriptTarget

    if {[string length $scriptTarget] == 0} return

    if {!$useIcons} {
        html "\n | "
    }
    html {<a href="http:} $env(SCRIPT_NAME)
    html / $sessionId / $scriptTarget
    if {$useIcons} {
        html {"><img src="/egwgif/button-new-target.gif" }
	html {alt="New Target" border=0></a>}
    } else {
        html {">New Target</a>}
    }
}

proc button-view-history {} {
    global useIcons
    global env
    global sessionId
    global nextSetNo

    if {!$useIcons} {
        html "\n | "
    }
    html {<a href="http:} $env(SCRIPT_NAME)
    html / $sessionId {/history.egw;}
    catch { html "/" $nextSetNo}
    if {$useIcons} {
        html {"><img src="/egwgif/button-view-history.gif" alt="View History" }
        html {border=0></a>}
    } else {
        html {">View History</a>}
    }
}

proc button-new-query {setNo} {
    global useIcons
    global env
    global sessionId
    global hist
    global scriptQuery

    if {!$useIcons} {
        html "\n | "
    }
    html {<a href="http:} $env(SCRIPT_NAME)
    html / $sessionId / $scriptQuery {;/} $setNo + $hist($setNo,0,host) {">}

    if {$useIcons} {
        html {<img src="/egwgif/button-new-query.gif" }
	html {alt="New Query" border=0></a>}
    } else {
        html {New Query</a>}
    }
}

proc button-result-set {setNo tno} {
    global useIcons
    global env
    global sessionId
    global hist

    if {!$useIcons} {
        html "\n | "
    }
    html {<a href="http:} $env(SCRIPT_NAME) / $sessionId 
    if {$tno > 0} {
        html {/msearch.egw/} $setNo
    } else {
        html {/search.egw/} $setNo + $tno
    }
    html + 1 + $hist($setNo,maxPresent)
    if {$useIcons} {
        html {"><img src="/egwgif/button-result-set.gif" }
	html {alt="Result Set" border=0></a>}
    } else {
        html {">Result Set</a>}
    }
}

proc button-scan-window {setNo} {
    global useIcons
    global env
    global sessionId
    global hist

    if {!$useIcons} {
        html "\n | "
    }
    set targetNo 0
    html {<a href="http:} $env(SCRIPT_NAME)
    html / $sessionId {/search.egw/} $setNo + $targetNo + {scan} {">}
    if {$useIcons} {
        html {<img src="/egwgif/button-scan-window.gif" }
	html {alt="Scan" border=0></a>}
    } else {
        html {Scan</a>}
    }
}

proc maintenance {} {
    html {<hr>This page is maintained by }
    html {<a href="mailto:nobody"> Nobody </a>.}
    html {Last modified x x x. <br>}
}

proc splitHostSpec {host} {
    set i [string first / $host]
    if {$i > 1} {
        incr i -1
        return [string range $host 0 $i]
    }
    return $host
}

proc splitDatabaseSpec {host} {
    set i [string first / $host]
    if {$i > 1} {
        incr i
        regsub -all -- - [string range $host $i end] { } res
        return $res
    }
    regsub -all -- - $host {} res
    return $res
}

proc mergeHostSpec {host databases} {
    return ${host}/[join $databases -]
}

proc mkAssoc {assoc host} {
    global targets

    if {[catch {$assoc failback fail-response}]} {
        ir $assoc
        $assoc maximumRecordSize 1000000
    } else {
        if {[$assoc comstack] == "tcpip"} return
        ir $assoc
        $assoc maximumRecordSize 1000000
    }
}

proc serverList {headlineProc targetProc} {
    global targets
    global groupsDescription
   
    proc targetsCmp {l r} {
        global targets
        return [string compare [string tolower [lindex $targets($l) 0]] \
                               [string tolower [lindex $targets($r) 0]]]
    }
    proc groupCmp {l r} {
        global groupsOrder
        if {[catch {set lo $groupsOrder($l)}]} {
            set lo 10
        }
        if {[catch {set ro $groupsOrder($r)}]} {
            set ro 10
        }
        return [expr $lo - $ro]
    }
    
    foreach tt [array names targets] {
        lappend groupsTmp([lindex $targets($tt) 6]) $tt
    }
    set gts [lsort -command groupCmp [array names groupsTmp]]
    foreach gt $gts {
        if {[info exists groupsDescription($gt)]} {
            eval $headlineProc [list $groupsDescription($gt)]
        } else {
            eval $headlineProc $gt
        }
        set tn [lsort -command targetsCmp $groupsTmp($gt)]
        foreach t $tn {
            eval $targetProc $t
        }
    }

    rename targetsCmp {}
}

proc session-lost {} {
    global useIcons

    html {<head><title>WWW/Z39.50 Gateway: Session Expired</title></head>}
    html \n {<body>}
    set useIcons 1
    button-main
    html {<h1>Session Expired</h1>}
    html {Your session has expired. Please reload the gateways' }
    html {front page.<br><br>} \n
    set useIcons 0
    button-main
    html {</body></html>}
}

if {[info exists utilExtension]} {
    source $utilExtension
}

